Index: applications/editors/josm/plugins/cadastre-fr/build.xml
===================================================================
--- applications/editors/josm/plugins/cadastre-fr/build.xml	(revision 13585)
+++ applications/editors/josm/plugins/cadastre-fr/build.xml	(revision 13587)
@@ -1,62 +1,45 @@
 <project name="cadastre-fr" default="dist" basedir=".">
+    <property name="josm"                   location="../../core/dist/josm-custom.jar" />
+    <property name="plugin.dist.dir"        value="../../dist"/>
+    <property name="plugin.build.dir"       value="build"/>
+    <property name="plugin.jar"             value="${plugin.dist.dir}/${ant.project.name}.jar"/>
+    <property name="ant.build.javac.target" value="1.5"/>
+    <target name="init">
+        <mkdir dir="${plugin.build.dir}"/>
+    </target>
+    <target name="compile" depends="init">
+        <echo message="creating ${plugin.jar}"/>
+        <javac srcdir="src" classpath="${josm}" destdir="${plugin.build.dir}" debug="true">
+            <include name="**/*.java" />
+        </javac>
+    </target>
 
-  <!-- compilation properties -->
-  <property name="josm.build.dir"	value="../../core"/>
-  <property name="josm.home.dir"	value="${user.home}/.josm"/>
-  <property name="josm"			location="../../core/dist/josm-custom.jar" />
-  <property name="plugin.build.dir"	value="build"/>
-  <property name="plugin.dist.dir"	value="../../dist"/>
-  <property name="plugin.name"		value="${ant.project.name}"/>
-  <property name="plugin.jar"		value="../../dist/${plugin.name}.jar"/>
-
-  <property name="ant.build.javac.target" value="1.5"/>
-  
-  <target name="init">
-    <mkdir dir="${plugin.build.dir}"/>
-  </target>
-
-  <target name="compile" depends="init">
-    <echo message="creating ${plugin.jar}"/>
-    <javac srcdir="src" classpath="${josm}" destdir="build" debug="true">
-      <include name="**/*.java" />
-    </javac>
-  </target>
-
-  <target name="dist" depends="compile">
-    <copy todir="${plugin.build.dir}/images">
-      <fileset dir="images"/>
-    </copy>
-    <exec append="false" output="REVISION" executable="svn" failifexecutionfails="false">
-      <env key="LANG" value="C"/>
-      <arg value="info"/>
-      <arg value="--xml"/>
-      <arg value="."/>
-    </exec>
-    <xmlproperty file="REVISION" prefix="version" keepRoot="false" collapseAttributes="true"/>
-    <delete file="REVISION"/>
-    <jar destfile="${plugin.jar}" basedir="${plugin.build.dir}">
-      <manifest>
-		<attribute name="Plugin-Class" value="cadastre_fr.CadastrePlugin"/>
-		<attribute name="Plugin-Description" value="A special handler for the french land registry WMS server"/>
-		<attribute name="Plugin-Version" value="${version.entry.commit.revision}"/>
-		<attribute name="Plugin-Date" value="${version.entry.commit.date}"/>
-		<attribute name="Plugin-Stage" value="60"/>
-		<attribute name="Author" value="Pieren &lt;pieren3@gmail.com>"/>
-      </manifest>
-    </jar>
-  </target>
-
-  <target name="clean">
-    <delete dir="${plugin.build.dir}" />
-    <delete file="${plugin.jar}" />
-  </target>
-  
-  <target name="install" depends="dist">
-    <copy file="${plugin.jar}" todir="${user.home}/.josm/plugins"/>
-  </target>
-
-  <target name="test" depends="install">
-    <java jar="${josm}" fork="true"/>
-  </target>
-
+    <target name="dist" depends="compile">
+        <copy todir="${plugin.build.dir}/images">
+            <fileset dir="images"/>
+        </copy>
+        <exec append="false" output="REVISION" executable="svn" failifexecutionfails="false">
+            <env key="LANG" value="C"/>
+            <arg value="info"/>
+            <arg value="--xml"/>
+            <arg value="."/>
+        </exec>
+        <xmlproperty file="REVISION" prefix="version" keepRoot="false" collapseAttributes="true"/>
+        <delete file="REVISION"/>
+        <jar destfile="${plugin.jar}" basedir="${plugin.build.dir}">
+            <manifest>
+                <attribute name="Plugin-Class" value="cadastre_fr.CadastrePlugin"/>
+                <attribute name="Plugin-Description" value="A special handler for the french land registry WMS server"/>
+                <attribute name="Plugin-Version" value="${version.entry.commit.revision}"/>
+                <attribute name="Plugin-Date" value="${version.entry.commit.date}"/>
+                <attribute name="Plugin-Stage" value="60"/>
+                <attribute name="Plugin-Mainversion" value="1280" />
+                <attribute name="Author" value="Pieren &lt;pieren3@gmail.com>"/>
+            </manifest>
+        </jar>
+    </target>
+    <target name="clean">
+        <delete dir="${plugin.build.dir}" />
+        <delete file="${plugin.jar}" />
+    </target>
 </project>