Index: trunk/src/org/openstreetmap/josm/gui/HelpAwareOptionPane.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/HelpAwareOptionPane.java	(revision 13840)
+++ trunk/src/org/openstreetmap/josm/gui/HelpAwareOptionPane.java	(revision 13842)
@@ -30,4 +30,5 @@
 import org.openstreetmap.josm.gui.widgets.JMultilineLabel;
 import org.openstreetmap.josm.tools.ImageProvider;
+import org.openstreetmap.josm.tools.ImageProvider.ImageSizes;
 import org.openstreetmap.josm.tools.InputMapUtils;
 import org.openstreetmap.josm.tools.Logging;
@@ -65,4 +66,16 @@
 
         private final Collection<ChangeListener> listeners = new HashSet<>();
+
+        /**
+         * Constructs a new {@code ButtonSpec}.
+         * @param text the button text
+         * @param imageProvider provides the icon to display. Can be null
+         * @param tooltipText the tooltip text. Can be null.
+         * @param helpTopic the help topic. Can be null.
+         * @since 13842
+         */
+        public ButtonSpec(String text, ImageProvider imageProvider, String tooltipText, String helpTopic) {
+            this(text, imageProvider != null ? imageProvider.setSize(ImageSizes.LARGEICON).get() : null, tooltipText, helpTopic, true);
+        }
 
         /**
Index: trunk/src/org/openstreetmap/josm/gui/dialogs/ConflictDialog.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/dialogs/ConflictDialog.java	(revision 13840)
+++ trunk/src/org/openstreetmap/josm/gui/dialogs/ConflictDialog.java	(revision 13842)
@@ -619,5 +619,5 @@
                     new ButtonSpec(
                             tr("OK"),
-                            ImageProvider.get("ok"),
+                            new ImageProvider("ok"),
                             tr("Click to close this dialog and continue editing"),
                             null /* no specific help */
Index: trunk/src/org/openstreetmap/josm/gui/dialogs/relation/actions/CancelAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/dialogs/relation/actions/CancelAction.java	(revision 13840)
+++ trunk/src/org/openstreetmap/josm/gui/dialogs/relation/actions/CancelAction.java	(revision 13842)
@@ -75,5 +75,5 @@
                 new ButtonSpec(
                         tr("Yes, save the changes and close"),
-                        ImageProvider.get("ok"),
+                        new ImageProvider("ok"),
                         tr("Click to save the changes and close this relation editor"),
                         null /* no specific help topic */
@@ -81,5 +81,5 @@
                 new ButtonSpec(
                         tr("No, discard the changes and close"),
-                        ImageProvider.get("cancel"),
+                        new ImageProvider("cancel"),
                         tr("Click to discard the changes and close this relation editor"),
                         null /* no specific help topic */
@@ -87,5 +87,5 @@
                 new ButtonSpec(
                         tr("Cancel, continue editing"),
-                        ImageProvider.get("cancel"),
+                        new ImageProvider("cancel"),
                         tr("Click to return to the relation editor and to resume relation editing"),
                         null /* no specific help topic */
Index: trunk/src/org/openstreetmap/josm/gui/dialogs/relation/actions/RefreshAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/dialogs/relation/actions/RefreshAction.java	(revision 13840)
+++ trunk/src/org/openstreetmap/josm/gui/dialogs/relation/actions/RefreshAction.java	(revision 13842)
@@ -85,5 +85,5 @@
                 new ButtonSpec(
                         tr("Yes, discard changes and reload"),
-                        ImageProvider.get("ok"),
+                        new ImageProvider("ok"),
                         tr("Click to discard the changes and reload data from layer"),
                         null /* no specific help topic */
@@ -91,5 +91,5 @@
                 new ButtonSpec(
                         tr("Cancel, continue editing"),
-                        ImageProvider.get("cancel"),
+                        new ImageProvider("cancel"),
                         tr("Click to return to the relation editor and to resume relation editing"),
                         null /* no specific help topic */
@@ -114,11 +114,11 @@
                 new ButtonSpec(
                         tr("Yes"),
-                        ImageProvider.get("ok"),
-                        tr("Click to close window"),
+                        new ImageProvider("ok"),
+                        tr("Click to closnew ImageProvidere window"),
                         null /* no specific help topic */
                 ),
                 new ButtonSpec(
                         tr("No, continue editing"),
-                        ImageProvider.get("cancel"),
+                        new ImageProvider("cancel"),
                         tr("Click to return to the relation editor and to resume relation editing"),
                         null /* no specific help topic */
Index: trunk/src/org/openstreetmap/josm/gui/dialogs/relation/actions/SavingAction.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/dialogs/relation/actions/SavingAction.java	(revision 13840)
+++ trunk/src/org/openstreetmap/josm/gui/dialogs/relation/actions/SavingAction.java	(revision 13842)
@@ -116,5 +116,5 @@
                 new ButtonSpec(
                         tr("Yes, create a conflict and close"),
-                        ImageProvider.get("ok"),
+                        new ImageProvider("ok"),
                         tr("Click to create a conflict and close this relation editor"),
                         null /* no specific help topic */
@@ -122,5 +122,5 @@
                 new ButtonSpec(
                         tr("No, continue editing"),
-                        ImageProvider.get("cancel"),
+                        new ImageProvider("cancel"),
                         tr("Click to return to the relation editor and to resume relation editing"),
                         null /* no specific help topic */
Index: trunk/src/org/openstreetmap/josm/gui/io/AbstractUploadTask.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/io/AbstractUploadTask.java	(revision 13840)
+++ trunk/src/org/openstreetmap/josm/gui/io/AbstractUploadTask.java	(revision 13842)
@@ -132,20 +132,14 @@
                 new ButtonSpec(
                         lbl,
-                        ImageProvider.get("updatedata"),
-                        null,
-                        null
-                ),
+                        new ImageProvider("updatedata"),
+                        null, null),
                 new ButtonSpec(
                         tr("Synchronize entire dataset"),
-                        ImageProvider.get("updatedata"),
-                        null,
-                        null
-                ),
+                        new ImageProvider("updatedata"),
+                        null, null),
                 new ButtonSpec(
                         tr("Cancel"),
-                        ImageProvider.get("cancel"),
-                        null,
-                        null
-                )
+                        new ImageProvider("cancel"),
+                        null, null)
         };
         String msg = tr("<html>Uploading <strong>failed</strong> because the server has a newer version of one<br>"
@@ -186,14 +180,10 @@
                 new ButtonSpec(
                         tr("Synchronize entire dataset"),
-                        ImageProvider.get("updatedata"),
-                        null,
-                        null
-                ),
+                        new ImageProvider("updatedata"),
+                        null, null),
                 new ButtonSpec(
                         tr("Cancel"),
-                        ImageProvider.get("cancel"),
-                        null,
-                        null
-                )
+                        new ImageProvider("cancel"),
+                        null, null)
         };
         String msg = tr("<html>Uploading <strong>failed</strong> because the server has a newer version of one<br>"
@@ -249,5 +239,5 @@
                 new ButtonSpec(
                         tr("Prepare conflict resolution"),
-                        ImageProvider.get("ok"),
+                        new ImageProvider("ok"),
                         tr("Click to download all referring objects for {0}", conflict.a),
                         null /* no specific help context */
@@ -255,5 +245,5 @@
                 new ButtonSpec(
                         tr("Cancel"),
-                        ImageProvider.get("cancel"),
+                        new ImageProvider("cancel"),
                         tr("Click to cancel and to resume editing the map"),
                         null /* no specific help context */
Index: trunk/src/org/openstreetmap/josm/gui/io/UploadPrimitivesTask.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/io/UploadPrimitivesTask.java	(revision 13840)
+++ trunk/src/org/openstreetmap/josm/gui/io/UploadPrimitivesTask.java	(revision 13842)
@@ -86,5 +86,5 @@
                 new ButtonSpec(
                         tr("Continue uploading"),
-                        ImageProvider.get("upload"),
+                        new ImageProvider("upload"),
                         tr("Click to continue uploading to additional new changesets"),
                         null /* no specific help text */
@@ -92,5 +92,5 @@
                 new ButtonSpec(
                         tr("Go back to Upload Dialog"),
-                        ImageProvider.get("dialogs", "uploadproperties"),
+                        new ImageProvider("dialogs", "uploadproperties"),
                         tr("Click to return to the Upload Dialog"),
                         null /* no specific help text */
@@ -98,5 +98,5 @@
                 new ButtonSpec(
                         tr("Abort"),
-                        ImageProvider.get("cancel"),
+                        new ImageProvider("cancel"),
                         tr("Click to abort uploading"),
                         null /* no specific help text */
Index: trunk/src/org/openstreetmap/josm/gui/layer/gpx/DownloadAlongPanel.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/layer/gpx/DownloadAlongPanel.java	(revision 13840)
+++ trunk/src/org/openstreetmap/josm/gui/layer/gpx/DownloadAlongPanel.java	(revision 13842)
@@ -167,5 +167,5 @@
                 new ButtonSpec(
                         tr("Download"),
-                        ImageProvider.get("download"),
+                        new ImageProvider("download"),
                         tr("Click to download"),
                         null // no specific help text
@@ -173,5 +173,5 @@
                 new ButtonSpec(
                         tr("Cancel"),
-                        ImageProvider.get("cancel"),
+                        new ImageProvider("cancel"),
                         tr("Click to cancel"),
                         null // no specific help text
Index: trunk/src/org/openstreetmap/josm/gui/oauth/AdvancedOAuthPropertiesPanel.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/oauth/AdvancedOAuthPropertiesPanel.java	(revision 13840)
+++ trunk/src/org/openstreetmap/josm/gui/oauth/AdvancedOAuthPropertiesPanel.java	(revision 13842)
@@ -164,5 +164,5 @@
                 new ButtonSpec(
                         tr("Continue"),
-                        ImageProvider.get("ok"),
+                        new ImageProvider("ok"),
                         tr("Click to reset the OAuth settings to default values"),
                         null /* no dedicated help topic */
@@ -170,5 +170,5 @@
                 new ButtonSpec(
                         tr("Cancel"),
-                        ImageProvider.get("cancel"),
+                        new ImageProvider("cancel"),
                         tr("Click to abort resetting to the OAuth default values"),
                         null /* no dedicated help topic */
Index: trunk/src/org/openstreetmap/josm/gui/preferences/plugin/PluginPreference.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/preferences/plugin/PluginPreference.java	(revision 13840)
+++ trunk/src/org/openstreetmap/josm/gui/preferences/plugin/PluginPreference.java	(revision 13842)
@@ -272,5 +272,5 @@
                 new ButtonSpec(
                         tr("OK"),
-                        ImageProvider.get("ok"),
+                        new ImageProvider("ok"),
                         tr("Accept the new plugin sites and close the dialog"),
                         null /* no special help topic */
@@ -278,5 +278,5 @@
                         new ButtonSpec(
                                 tr("Cancel"),
-                                ImageProvider.get("cancel"),
+                                new ImageProvider("cancel"),
                                 tr("Close the dialog"),
                                 null /* no special help topic */